;-----------------------------LICENSE NOTICE--------------------------------------------------
;  This file is part of "OH NO, My Moustache!" an Amstrad CPC 464  game developed for the CPCRetrodev2022
;  Copyright (C) 2022 Strawberry Studio. You can find us on twitter: @Strawberryabp

;
;  This program is free software: you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published by
;  the Free Software Foundation, either version 3 of the License, or
;  (at your option) any later version.
;
;  This program is distributed in the hope that it will be useful,
;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;  GNU Lesser General Public License for more details.
;
;  You should have received a copy of the GNU Lesser General Public License
;  along with this program. See the license.txt archive.
;  If not, see <http://www.gnu.org/licenses/>.
;----------------------------------------------------------------------------------------------

;;; ENTITY MANAGER
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;; FUNCIONES PUBLICAS
.globl entitymanager_create
.globl entitymanager_create_enemy
.globl entitymanager_create_special_enemy
.globl isValid
.globl isValidForSignature
.globl entitymanager_destroy
.globl entitymanager_get_sprite
.globl entitymanager_set_sprite
.globl entitymanager_update_lifes_player
.globl entitymanager_update_lifes_enemy
.globl entitymanager_update_enemy_spawn


;;; VARIABLES GLOBALES
.globl _entity_array
.globl _last_elem_ptr
.globl _num_entities
.globl _max_lifes
;.globl _cambio_en_vidas
.globl _num_enemies
.globl _num_max_enemies
.globl _num_max_enemy_life
.globl _carril_array
.globl _carril_array_inv


;;; CONSTANTES
entity_size     = 14
max_entities    = 30
carril_size     = 3
max_enemies     = 2

;;; TYPES DE LAS ENTIDADES
typeInvalid     = 0x00
typeRenderable  = 0x01
typeMovable     = 0x02
typeInput       = 0x04  ; Jugador
typeEnemyDead   = 0x08  ; Animations for EnemyDeath
typeBullet      = 0x10  ; Bala
typeEnemy       = 0x20  ; Enemigos
typeSpecialEnemy = 0x40  ; Enemigo TP
typeDead        = 0x80
typeDefault     = 0x7F

;;; CHECKERS DEL JUGADOR
isMoving        = 0x01
isBulletActive  = 0x02
isShootCooldownActive = 0x04
isSpriteOne     = 0x08

;;; DATA / CHECKERS DEL ENEMIGO TP
isTPStart       = 0x01
isTPCarril      = 0x02
isTPEnd         = 0x04
isTPSpeed       = 0x08
isTPDone        = 0x80

;;; VARIABLES DE LAS ENTIDADES 
type    = 0     
lifes   = 1     ; lifes  = jugador & enemigos
attack  = 1     ; attack = daño que hacen las balas a los enemigos
posx    = 2
posy    = 3
carril  = 4
width   = 5
height  = 6
vx      = 7
vy      = 8
checkers  = 9
sprite    = 10     ; Ocupa 2 bytes por ser direccion a memoria
data = 12           ;/ 2 bytes de datos adicionales (si es
datacheckers = 13   ;\ funcion xtra o simplemente datos)