;-----------------------------LICENSE NOTICE--------------------------------------------------
;  This file is part of "OH NO, My Moustache!" an Amstrad CPC 464  game developed for the CPCRetrodev2022
;  Copyright (C) 2022 Strawberry Studio. You can find us on twitter: @Strawberryabp

;
;  This program is free software: you can redistribute it and/or modify
;  it under the terms of the GNU Lesser General Public License as published by
;  the Free Software Foundation, either version 3 of the License, or
;  (at your option) any later version.
;
;  This program is distributed in the hope that it will be useful,
;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;  GNU Lesser General Public License for more details.
;
;  You should have received a copy of the GNU Lesser General Public License
;  along with this program. See the license.txt archive.
;  If not, see <http://www.gnu.org/licenses/>.
;----------------------------------------------------------------------------------------------

.include "cpctelera.h.s"
.include "globals.h.s"
.include "../sprites/inicio_z.h.s"
.include "../sprites/game_over_z.h.s"

.include "../sprites/instructions_z.h.s"

startGameState::
    ld hl,  #_inicio_z_end
    ld de, #0xFFFF
    call cpct_zx7b_decrunch_s_asm

    ld de, #_song_title
    call cpct_akp_musicInit_asm

    ld de, #_song_title
    call cpct_akp_SFXInit_asm

    call checkCKeyPressed

    
ret


instructionsState::
    ld hl,  #_instructions_z_end
    ld de, #0xFFFF
    call cpct_zx7b_decrunch_s_asm

    call checkCKeyPressed

ret

endGameState::

    ld hl,  #_game_over_z_end
    ld de, #0xFFFF
    call cpct_zx7b_decrunch_s_asm

    ld de, #_song_gameover
    call cpct_akp_musicInit_asm

    ld de, #_song_gameover
    call cpct_akp_SFXInit_asm

    checkEndGame:

        call cpct_waitVSYNC_asm
        call cpct_akp_musicPlay_asm

        call cpct_scanKeyboard_f_asm
        ld hl, #Key_C
        call cpct_isKeyPressed_asm

        jr z, keepChecking
            call startGameState
            ret
        keepChecking:
    jr checkEndGame
    
ret

checkCKeyPressed::
    checkpressedKeys:

        call cpct_waitVSYNC_asm
        call cpct_akp_musicPlay_asm
        call cpct_scanKeyboard_f_asm
        call cpct_isAnyKeyPressed_asm
        jr z, checkpressedKeys
            call cpct_scanKeyboard_f_asm
            ld hl, #Key_C
            call cpct_isKeyPressed_asm
            ret nz

    jr checkpressedKeys
ret